%token<string>	IDENT
%token<int>	NUMBER
%token          BADTOK EOF
%token          LAMBDA  AT DOT
%token          DOT LPAR RPAR

%start		                expression
%type<Sct_lambda.lambda_expr>  expression

%{
open Sct_lambda;;
%}

%%

expression:
  abstraction                                    {$1}
| application                                    {$1}
| variable                                       {$1};

application:
  operator operand                               { Appl($1,$2) }
 | operator AT operand                           { Appl($1,$3) };

operand:
  variable                                       { $1 }
 | LPAR expression RPAR                          { $2 };

operator:
  operand                                        { $1 }
 | application                                   { $1 }

abstraction:
  LAMBDA IDENT DOT expression                    { Abstr($2,$4) };

variable:
  IDENT                                          { Var($1) };

